/******************************************************************************
  Include di sistema 
******************************************************************************/
#include	<stdrom.h>
#include	"define.h"
#include	"libc.h"
#include	"L_define.h"
#include	"L_libc.h"

/******************************************************************************
  Include applicazione
******************************************************************************/
#include	"ExprInp.h"
#include	"Parser.h"

/*****************************************************************************
	Variabili globali
*****************************************************************************/
/* usate nel plot delle funzioni */
double x_var_min, x_var_max, y_var_min, y_var_max;
int    finezza; 

/* Stringa contenente l'espressione da calcolare / graficare */
byte AppoggioEspressione[STRING_MAX + 1];

/*****************************************************************************
	Variabili esterne
*****************************************************************************/
extern byte     result[MAX_STRLEN]; /* result buffer (parser.c) */

/*****************************************************************************
	Prototipi di funzione
*****************************************************************************/
void ParserMain(void);
void StringInput(byte *);

/******************************************************************************
    [Title]		ProgramMain

******************************************************************************/
void main()
{
	for(;;){
		ParserMain();
	}
}

/******************************************************************************
    [Title]        ParserMain

    [arguments]		none

    [return value]	none

******************************************************************************/
void ParserMain(void)
{
int Err = 0;

	byte Stringa[STRING_MAX + 1];

	LibOpenWindow(0,0,160,160);

	LibPutFarData(65, 0, 110);
	LibPutProStr(IB_PFONT1,75,2,"Clr",38);
	LibPutProStr(IB_PFONT1,100,2,"Calc",38);
	LibPutProStr(IB_PFONT1,128,2,"Plot",38);

	LibPutFarData((LCD_X_DOT-128)/2,27,107); 
	LibPutProStr(IB_PFONT1,(LCD_X_DOT-128)/2 + 5,32,
		"Expression:",70); 

	/* Caricamento funzioni definite da utente */
	Err = LoadUserFunc();

	/* Inserimento espressione e sua elaborazione */
	StringInput(Stringa);

	LibCloseWindow();

}

/******************************************************************************/
/* Setup Procedure  		                                                */
/******************************************************************************/
#if 0
double StringToDouble(char string[10]){
	int i=0,z=0,nachkomma=0;
	double result=0;
	double dtmp=0;
	int negativ=0;

	while(string[i]){
		if(string[i]=='.') {
			nachkomma=1;
		}
		else if(string[i]=='-') {
			negativ=1;
		}else{
			if(!nachkomma) {
				result*=10;
				result+=string[i]-48;
			} else {
				dtmp=string[i]-48;
				for(z=0;z<nachkomma;z++) dtmp/=10;
				result+=dtmp;
				nachkomma++;
			}
		}
		i++;
	}
	if(negativ) result*=-1;

	return (result);
}
#endif

/******************************************************************************/
double ParseValue(byte *Expr){
	int err;
	double value;
	byte *pExpr;

	pExpr = Expr;
	parseinit();
	err = parse(&pExpr);
	err |= getvaltop(&value);

	if (err)	
		return (0.0);
	else
		return (value);
}

/******************************************************************************/
static void SetupProc(){
	TXTP		FTxtInput;	/* Declaration of structure for text input */
	TXTP		FTxtInput2;	/* Declaration of structure for text input */
	TXTP		FTxtInput3;	/* Declaration of structure for text input */
	TXTP		FTxtInput4;	/* Declaration of structure for text input */
	TXTP		FTxtInput5;	/* Declaration of structure for text input */
	TCHTBL	TchTxtBuf[3]; /* Text touch area table */
	word		GdTbl[1]; /* Guidance comment table */
	T_SCR_POS	ComScr; /* Scroll bar position information */
	byte		key_cd;
	TCHSTS	tsts;
	byte		input_end;
	char        function[1024];  /* function txt buffer */
	char 		tmpfunction[1024]; /* function txt buffer */
	TXTP		*CurrentInput;
	char		sxmin[10];
	char		sxmax[10];
	char		symin[10];
	char		symax[10];

	/* initial data */
	memset(tmpfunction,0x00,sizeof(tmpfunction));
	strcpy(tmpfunction,function);
	memset(sxmin,0x00,sizeof(sxmin));
	memset(sxmax,0x00,sizeof(sxmax));
	memset(symin,0x00,sizeof(symin));
	memset(symax,0x00,sizeof(symax));
	sprintf(sxmin,"%f",x_var_min);
	sprintf(sxmax,"%f",x_var_max);
	sprintf(symin,"%f",y_var_min);
	sprintf(symax,"%f",y_var_max);

	/* open setup window */
	LibOpenWindow(0,0,160,160);

	/* sraw Plot Graph Button */
	LibPutProStr(IB_PFONT1,100,77,"OK",50);
	LibGdsBox(80,75,130,86);

/**********************
	/^ draw Function-Term TextBox ^/
	LibPutProStr(IB_PFONT1,15,8,"Function Term",100);
	LibGdsBox(15,18,105,30);
**********************/

	/* draw xmin TextBox */
	LibPutProStr(IB_PFONT1,15,35,"xmin",25);
	LibGdsBox(15,45,40,56);

	/* draw xmax TextBox */
	LibPutProStr(IB_PFONT1,50,35,"xmax",25);
	LibGdsBox(50,45,75,56);

	/* draw ymin TextBox */
	LibPutProStr(IB_PFONT1,85,35,"ymin",25);
	LibGdsBox(85,45,115,56);

	/* draw ymax TextBox */
	LibPutProStr(IB_PFONT1,125,35,"ymax",25);
	LibGdsBox(125,45,150,56);
	LibPutDisp();

	/* Function Input TxtBox */
	GdTbl[0]	= 0xffff;	/* No Guidance comment */
	FTxtInput.st_x	= 20;		/* Start coordinate (X) of text display */
	FTxtInput.st_y	= 20;		/* Start coordinate (Y) of text display */
	FTxtInput.ed_x	= 100;		/* End coordinate (X) of text display  */
	FTxtInput.it_y	= 9;		/* Text display line spacing (Y) */
	FTxtInput.MAXGYO= 1;		/* Number of text display lines  */
	FTxtInput.font	= IB_PFONT1;	/* Display font type  */
	FTxtInput.csen	= TRUE;		/* Cursor display enabled(Keyword registration enabled) */
	FTxtInput.rtnen	= 0x02;		/* CR code display enabled  */
	FTxtInput.maxmj	= 1024;		/* Maximum number of allowable input characters. */
	FTxtInput.txbf	= tmpfunction;	/* Designation of text buffer address  */
	FTxtInput.gdcmt	= GdTbl;	/* Guidance comment table  */
	FTxtInput.txtobj= NULL;		/* Object when text area is touched.  */
	FTxtInput.sbrobj= NULL;		/* Object when the scroll bar is touched. */
	FTxtInput.tchtb	= TchTxtBuf;	/* Pointer for text scroll bar area  */
	FTxtInput.s_pos	= &ComScr;	/* Pointer for text and scroll bar information */

	/* xmin Input TxtBox */
	GdTbl[0]	 = 0xffff;	/* No Guidance comment */
	FTxtInput2.st_x	 = 17;		/* Start coordinate (X) of text display */
	FTxtInput2.st_y	 = 47;		/* Start coordinate (Y) of text display */
	FTxtInput2.ed_x	 = 39;		/* End coordinate (X) of text display  */
	FTxtInput2.it_y	 = 9;		/* Text display line spacing (Y) */
	FTxtInput2.MAXGYO= 1;		/* Number of text display lines  */
	FTxtInput2.font	 = IB_PFONT1;	/* Display font type  */
	FTxtInput2.csen	 = TRUE;	/* Cursor display enabled(Keyword registration enabled) */
	FTxtInput2.rtnen = 0x02;	/* CR code display enabled  */
	FTxtInput2.maxmj = 10;		/* Maximum number of allowable input characters. */
	FTxtInput2.txbf	 = sxmin;	/* Designation of text buffer address  */
	FTxtInput2.gdcmt = GdTbl;	/* Guidance comment table  */
	FTxtInput2.txtobj= NULL;	/* Object when text area is touched.  */
	FTxtInput2.sbrobj= NULL;	/* Object when the scroll bar is touched. */
	FTxtInput2.tchtb = TchTxtBuf;	/* Pointer for text scroll bar area  */
	FTxtInput2.s_pos = &ComScr;	/* Pointer for text and scroll bar information */

	/* xmax Input TxtBox */
	GdTbl[0]	 = 0xffff;	/* No Guidance comment */
	FTxtInput3.st_x	 = 52;	/* Start coordinate (X) of text display */
	FTxtInput3.st_y	 = 47;	/* Start coordinate (Y) of text display */
	FTxtInput3.ed_x	 = 74;	/* End coordinate (X) of text display  */
	FTxtInput3.it_y	 = 9;		/* Text display line spacing (Y) */
	FTxtInput3.MAXGYO= 1;		/* Number of text display lines  */
	FTxtInput3.font	 = IB_PFONT1;	/* Display font type  */
	FTxtInput3.csen	 = TRUE;	/* Cursor display enabled(Keyword registration enabled) */
	FTxtInput3.rtnen = 0x02;	/* CR code display enabled  */
	FTxtInput3.maxmj = 10;		/* Maximum number of allowable input characters. */
	FTxtInput3.txbf	 = sxmax;	/* Designation of text buffer address  */
	FTxtInput3.gdcmt = GdTbl;	/* Guidance comment table  */
	FTxtInput3.txtobj= NULL;	/* Object when text area is touched.  */
	FTxtInput3.sbrobj= NULL;	/* Object when the scroll bar is touched. */
	FTxtInput3.tchtb = TchTxtBuf;	/* Pointer for text scroll bar area  */
	FTxtInput3.s_pos = &ComScr;	/* Pointer for text and scroll bar information */

	/* ymin Input TxtBox */
	GdTbl[0]	 = 0xffff;	/* No Guidance comment */
	FTxtInput4.st_x	 = 87;	/* Start coordinate (X) of text display */
	FTxtInput4.st_y	 = 47;	/* Start coordinate (Y) of text display */
	FTxtInput4.ed_x	 = 114;	/* End coordinate (X) of text display  */
	FTxtInput4.it_y	 = 9;		/* Text display line spacing (Y) */
	FTxtInput4.MAXGYO= 1;		/* Number of text display lines  */
	FTxtInput4.font	 = IB_PFONT1;	/* Display font type  */
	FTxtInput4.csen	 = TRUE;	/* Cursor display enabled(Keyword registration enabled) */
	FTxtInput4.rtnen = 0x02;	/* CR code display enabled  */
	FTxtInput4.maxmj = 10;		/* Maximum number of allowable input characters. */
	FTxtInput4.txbf	 = symin;	/* Designation of text buffer address  */
	FTxtInput4.gdcmt = GdTbl;	/* Guidance comment table  */
	FTxtInput4.txtobj= NULL;	/* Object when text area is touched.  */
	FTxtInput4.sbrobj= NULL;	/* Object when the scroll bar is touched. */
	FTxtInput4.tchtb = TchTxtBuf;	/* Pointer for text scroll bar area  */
	FTxtInput4.s_pos = &ComScr;	/* Pointer for text and scroll bar information */

	/* ymax Input TxtBox */
	GdTbl[0]	 = 0xffff;	/* No Guidance comment */
	FTxtInput5.st_x	 = 127;		/* Start coordinate (X) of text display */
	FTxtInput5.st_y	 = 47;		/* Start coordinate (Y) of text display */
	FTxtInput5.ed_x	 = 149;		/* End coordinate (X) of text display  */
	FTxtInput5.it_y	 = 9;		/* Text display line spacing (Y) */
	FTxtInput5.MAXGYO= 1;		/* Number of text display lines  */
	FTxtInput5.font	 = IB_PFONT1;	/* Display font type  */
	FTxtInput5.csen	 = TRUE;	/* Cursor display enabled(Keyword registration enabled) */
	FTxtInput5.rtnen = 0x02;	/* CR code display enabled  */
	FTxtInput5.maxmj = 10;		/* Maximum number of allowable input characters. */
	FTxtInput5.txbf	 = symax;	/* Designation of text buffer address  */
	FTxtInput5.gdcmt = GdTbl;	/* Guidance comment table  */
	FTxtInput5.txtobj= NULL;	/* Object when text area is touched.  */
	FTxtInput5.sbrobj= NULL;	/* Object when the scroll bar is touched. */
	FTxtInput5.tchtb = TchTxtBuf;	/* Pointer for text scroll bar area  */
	FTxtInput5.s_pos = &ComScr;	/* Pointer for text and scroll bar information */

	LibTchStackClr();
	LibTchStackPush(NULL);
	LibTchStackPush(TchHardIcon);		  /* Hardware Icons   */
	LibTchStackPush(TchSetupDialogItems); /* Dialog Button(s) */

/**********************
	LibTxtInit(&FTxtInput);
	LibTxtTchSet(&FTxtInput);
**********************/

	LibTxtInit(&FTxtInput2);
	LibTxtTchSet(&FTxtInput2);

	LibTxtInit(&FTxtInput3);
	LibTxtTchSet(&FTxtInput3);

	LibTxtInit(&FTxtInput4);
	LibTxtTchSet(&FTxtInput4);

	LibTxtInit(&FTxtInput5);
	LibTxtTchSet(&FTxtInput5);

	CurrentInput=&FTxtInput2;

	/* show all updated txt input fields */
/**********************
	LibTxtDsp(&FTxtInput);
*********************/
	LibTxtDsp(&FTxtInput2);
	LibTxtDsp(&FTxtInput3);
	LibTxtDsp(&FTxtInput4);
	LibTxtDsp(&FTxtInput5);

	LibDispKey();
	input_end=FALSE;

	while(input_end==FALSE){
		LibTxtDsp(CurrentInput);
		LibPutDisp();
		key_cd=LibGetKeyM(&tsts);	/* get event	*/
		if(key_cd==KEY_NONE){		/* Not keyboard */
			switch(tsts.obj){

				case OBJ_HIC_MBAR:
					LibEditPullDown();
					break;

				case TCH_SETUP_OK:
					if(LibBlockIconClick(&TchSetupOKButton,&tsts,B_ICON_RIGHT)==TRUE){
						memset(function,0x00,sizeof(function));
						strcpy(function,tmpfunction);
						x_var_min=ParseValue(sxmin);
						x_var_max=ParseValue(sxmax);
						y_var_min=ParseValue(symin);
						y_var_max=ParseValue(symax);
						input_end=TRUE;
						}
					break;
/**********************
				case TCH_SETUP_FUNCTION_TXT:
					CurrentInput=&FTxtInput;
					break;
**********************/

				case TCH_SETUP_XMIN_TXT:
					CurrentInput=&FTxtInput2;
					break;

				case TCH_SETUP_XMAX_TXT:
					CurrentInput=&FTxtInput3;
					break;

				case TCH_SETUP_YMIN_TXT:
					CurrentInput=&FTxtInput4;
					break;

				case TCH_SETUP_YMAX_TXT:
					CurrentInput=&FTxtInput5;
					break;

				case OBJ_HIC_ESC:
					input_end=TRUE;
					break;
			}
		}
		LibTxtInp(key_cd,&tsts,CurrentInput);
	}
	LibCloseWindow();

	return;
}

/******************************************************************************/
static void PlotFunction(byte *Expr)
{
TCHSTS tsts;
double x_var, y_var, old_x_var, old_y_var, x_var_step;
int    x_dot, y_dot, old_x, old_y;
int    percento;
int    err = 0;
byte   first_dot = TRUE, out_of_range = FALSE;
byte   *pExpr;
byte   temp[150];


      /********************************************************/
      /*  VALORI INIZIALI                                     */
	x_var_min = -10.0;
	x_var_max = 10.0;
	y_var_min = -3.0;
	y_var_max = 3.0;
	finezza = 1;  /* numero di punti calcolati per ogni dot */
      /********************************************************/

	LibOpenWindow(0,0,160,160);

      /********************************************************/
	/* Andrebbe richiamata da un pulsante apposito !        */
      SetupProc(); /* Chiama il setup degli intervalli        */
      /********************************************************/

	LibPutFarData(99, 0, 132);
	LibPutProStr(IB_PFONT1,102,2,"Close",38);
	LibTchStackPush(TchHardIcon);
	LibTchStackPush(TchHeaderIcon3);
	LibTchInit();

	LibBox(X_P_LEFT, Y_P_TOP, X_P_WIDTH, Y_P_HEIGHT, 1);
	LibPutDisp();

	pExpr = Expr;
       x_var_step = (x_var_max - x_var_min)/
                   (double)(X_P_WIDTH)/(double)finezza;

	/***********************/
	/** DEBUG **************/
	sprintf(temp, "%f %f %f %f %f %f",
		x_var_min, x_var_max, y_var_min, y_var_max,
		x_var, y_var);
	/***********************/

      /* loop sui punti da calcolare */
	for (x_var = x_var_min; x_var <= x_var_max; x_var += x_var_step)
	{

         /* Calcola l'ascissa del punto nella finestra */
         x_dot = X_P_LEFT + (int)((double)(x_var - x_var_min) * 
               (double)(X_P_WIDTH - 1)/(double)(x_var_max - x_var_min));

         /* interpreta l'espressione */
         pExpr = Expr;
         parseinit();
         setvar_name(USER_X_VAR, x_var);
         err = parse(&pExpr);
         err |= getvaltop(&y_var);


         percento = (int)(100 * (x_dot - X_P_LEFT) / X_P_WIDTH);
         sprintf (temp, "Plotting... (%d %)", percento);
         LibPutProStr(IB_PFONT1, X_P_LEFT, Y_P_TOP - 10, temp, 80);

	/***********************/
	/** DEBUG **************
	sprintf(temp, "%f %f %f %f %f %f",
		x_var_min, x_var_max, y_var_min, y_var_max,
		x_var, y_var);
	***********************/

         if (err) first_dot = TRUE; /* Errore nel parsing */
         else {

	      /* Controlla se sono nel range del display */
	      if (y_var > y_var_max || y_var < y_var_min ) {

               /* calcola il punto sul bordo */
               if (y_var > y_var_max)
                   y_dot = Y_P_TOP;
               else
                   y_dot = Y_P_TOP + Y_P_HEIGHT - 1;

               /* Se  il primo fuori-range, traccia la linea */ 
		   if (!out_of_range)
                   if (!first_dot)
                       LibPutLineSub(old_x, old_y, x_dot, y_dot, IB_GDS_OR);
                   else {
                       LibPutDotSub(x_dot, y_dot, IB_GDS_OR);
                       first_dot = FALSE;
               }

               out_of_range = TRUE;

	      }
	      else {

               out_of_range = FALSE;

		   /* calcola l'ordinata del punto nella finestra */
		   y_dot = Y_P_TOP + (int)((double)(y_var_max - y_var) * 
                     (double)(Y_P_HEIGHT - 1)/(double)(y_var_max - y_var_min));
		  
		   if (first_dot){
		      LibPutDotSub(x_dot, y_dot, IB_GDS_OR);
		      first_dot = FALSE;
		   } else
		      LibPutLineSub(old_x, old_y, x_dot, y_dot, IB_GDS_OR);

	      }

	      /* Send to screen */
	      LibPutDisp();

	      /* Save for next loop */
	      old_x = x_dot;
	      old_y = y_dot;
	      old_x_var = x_var;
	      old_y_var = y_var;
         }
	}

      /* Attende la pressione del tasto 'CLOSE' */
	for(;;){
		LibTchWait(&tsts);
		switch(tsts.obj){
			case OBJ_HIC_MBAR:
				LibEditPullDown();
				break;

			case OBJ_IC_CLOSE :
				if(LibBlockIconClick( &TiconCalc, &tsts , 
					B_ICON_CENTER ) == TRUE)
					LibTchInit();

				LibPutDisp();
				LibCloseWindow();
				return;

			default:
				break;
		}
	}

	LibCloseWindow();

	return;
}


/******************************************************************************
*	[Title]	General String Input
*	[Arguments]	Stringa inserita
*	[ReturnVAL]	None
******************************************************************************/
void StringInput(byte *EditString)
{

TXTP        EventPrm;         /* Declaration of structure for text input */
TCHTBL      TchTxtBuf[3];     /* Text touch area table */
T_SCR_POS   ComScr;           /* Scroll bar position information */
word        GdTbl[1];         /* Guidance comment table */

byte		key_cd;
TCHSTS	tsts;
byte		input_end;

int Err = 0;
byte *pEspressione;

	GdTbl[0]		= 0xffff;		/* No Guidance comment */
	EventPrm.st_x	= (LCD_X_DOT-128)/2 + 5; /* Start coordinate (X) of text display */
	EventPrm.st_y	= 41;			/* Start coordinate (Y) of text display */
	EventPrm.ed_x	= 137;		/* End coordinate (X) of text display  */
	EventPrm.it_y	= 9;			/* Text display line spacing (Y) */
	EventPrm.MAXGYO	= 3;			/* Number of text display lines  */
	EventPrm.font	= IB_PFONT1;	/* Display font type  */
	EventPrm.csen	= TRUE;		/* Cursor display enabled(Keyword registration enabled) */
	EventPrm.rtnen	= 0x02;		/* CR code display enabled  */
	EventPrm.maxmj	= STRING_MAX;	/* Maximum number of allowable input characters. */
	EventPrm.txbf	= EditString;	/* Designation of text buffer address  */
	EventPrm.gdcmt = GdTbl;		/* Guidance comment table  */
	EventPrm.txtobj = OBJ_STRING;	/* Object when text area is touched.  */
	EventPrm.sbrobj = NULL;		/* Object when the scroll bar is touched. */
	EventPrm.tchtb = TchTxtBuf;	/* Pointer for text scroll bar area  */
	EventPrm.s_pos = &ComScr; /* Pointer for text and scroll bar information */

	LibTchStackPush( NULL );
	LibTchStackPush( TchHardIcon );
	LibTchStackPush( TchHeaderIcon2 );

	EditString[0] = 0;				/* Initialization of text buffer */
	LibTxtInit(&EventPrm);				/* Initialization of text input */
	LibTxtTchSet(&EventPrm);			/* Text touch area PUSH */

    	LibDispKey();

	input_end = FALSE;
	while(input_end == FALSE){

		LibTxtDsp(&EventPrm);
		LibPutDisp();

		key_cd = LibGetKeyM(&tsts);

		if(key_cd == KEY_NONE){	/* Not keyboard */
			switch(tsts.obj){
				case OBJ_HIC_MBAR:
					LibEditPullDown();
					break;

				case OBJ_IC_CALC:
					if(LibBlockIconClick( &TiconCalc, &tsts , 
						B_ICON_CENTER ) == TRUE)
						LibTchInit();
						/* input_end = TRUE; */
					LibPutDisp();

					strcpy (AppoggioEspressione, EditString);

					/* initializza per il parsing */
				 	parseinit();

					/* Calcola il risultato dell'espressione */
					pEspressione = AppoggioEspressione;
				  	Err = parse(&pEspressione); 
					 /* Controlla e formatta il risultato */
					Err = printresult();

					/* Stampa il risultato (o l'errore) */
					LibPutProStr(IB_PFONT1,1,8,"Result:",50); 
					LibClrBox(5,16,120,9);
					LibPutProStr(IB_PFONT1,5,16,result,120);	
					LibPutDisp();

					break;

				case OBJ_IC_PLOT:
					if(LibBlockIconClick( &TiconPlot, &tsts , 
						B_ICON_RIGHT ) == TRUE)
						LibTchInit();
					LibPutDisp();

					strcpy (AppoggioEspressione, EditString);
                                      /* Apre la finestra del plot */
					PlotFunction(AppoggioEspressione);
      
                                      /* Re-inizializza l'interfaccia */
	                              LibTchStackPush( NULL );
	                              LibTchStackPush( TchHardIcon );
	                              LibTchStackPush( TchHeaderIcon2 );

                                      LibTxtInit(&EventPrm);
                                      LibTxtTchSet(&EventPrm);
                                      LibDispKey();

					break;

				case OBJ_IC_CLR:
					if(LibBlockIconClick( &TiconClr, &tsts , 
						B_ICON_LEFT ) == TRUE)
					{
						EditString[0] = 0;
						LibTxtInit(&EventPrm);
					}
					break;

				case OBJ_STRING:
					break;

			}
		}

		LibTxtInp(key_cd,&tsts,&EventPrm);
	}
}

/*TAIL*/
